/************************************************************************
 *                  FileConverter JAVA ARE2Coords v2.0                  *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/
 
import java.util.*;
import java.io.File;
class ARE2Coords extends Toolbox {
  private File fileName;
  private Vector<Point23> points = null;
  
  public ARE2Coords () { }

  public ARE2Coords(File f){
    if (f.exists() && f.isFile() && f.canRead() && (f.toString().toLowerCase().endsWith( ".are" ) || f.toString().toLowerCase().endsWith( ".job" ))){
      this.fileName = f;
      this.points = new Vector<Point23>();
      if (!this.getCoords() || this.points.size() < 1)
        this.points = null;
    }
  }
  
  public Vector getPoints(){
    return this.points;
  }
  
  private boolean getCoords(){
    if (this.fileName == null)
      return false;

    Vector<String> v = this.readSourcefile( this.fileName );
    if (v == null)
      return false;
    Point23 p23 = null;
    for (int i=0; i<v.size(); i++){
      if (!v.get(i).matches("([0-9]+).*?=(.+)"))
        continue;
      try{
        int key = Integer.parseInt(v.get(i).replaceAll("([0-9]+).*?=(.+)", "$1"));
        String value = v.get(i).replaceAll("([0-9]+).*?=(.+)", "$2").trim();
        if ((key == 4 || key == 5 || key == 37 || key == 38 || key == 39) && !value.equals("") ){
          if (key == 5){
            if (p23 != null && p23.is2DPoint())
              this.points.add( p23 );
            p23 = new Point23();
            p23.setPKT( value );
          }

          else if(p23 != null && key == 4){
            p23.setCode( value );
          }
          else if(p23 != null && key == 37){
            try{
              p23.setX(new Double( Double.parseDouble( value ) ));
            } catch(Exception e) {  }
          }
          else if(p23 != null && key == 38){
            try{
              p23.setY(new Double( Double.parseDouble( value ) ));
            } catch(Exception e) {  }
          }
          else if(p23 != null && key == 39){
            try{
              p23.setZ(new Double( Double.parseDouble( value ) ));
            } catch(Exception e) {  }
          }

          if (p23 != null && v.size()-1 == i && p23.is2DPoint())
            this.points.add( p23 );
        }
      } catch(Exception e) {  }
    }
    return true;
  }

}

