/************************************************************************
 *                FileConverter JAVA ConvertPanel v1.0                  *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/
 
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;
import java.util.Hashtable;

public class ConvertPanel extends JPanel{
  public Vector<JRadioButton> sJR = new Vector<JRadioButton>();
  public Vector<JRadioButton> rJR = new Vector<JRadioButton>();
  public JRadioButton JRB_in_GSI_8 = new JRadioButton("",true);
  public JRadioButton JRB_in_GSI_16 = new JRadioButton();
  public JRadioButton JRB_in_DAT = new JRadioButton();
  public JRadioButton JRB_in_ARE = new JRadioButton();
  public JRadioButton JRB_in_PKT = new JRadioButton();
  public JRadioButton JRB_in_K = new JRadioButton();
  public JRadioButton JRB_in_CSV = new JRadioButton();
  public JRadioButton JRB_in_M5 = new JRadioButton();
  public JRadioButton JRB_in_OO1 = new JRadioButton();
  private ButtonGroup inBG = new ButtonGroup();
  private JPanel inJP = new JPanel();

  public JRadioButton JRB_out_GSI_8 = new JRadioButton();
  public JRadioButton JRB_out_GSI_16 = new JRadioButton("",true);
  public JRadioButton JRB_out_DAT = new JRadioButton();
  public JRadioButton JRB_out_ARE = new JRadioButton();
  public JRadioButton JRB_out_PKT = new JRadioButton();
  public JRadioButton JRB_out_K = new JRadioButton();
  public JRadioButton JRB_out_CSV = new JRadioButton();
  public JRadioButton JRB_out_M5 = new JRadioButton();
  public JRadioButton JRB_out_OO1 = new JRadioButton();
  public JButton saveSettings = new JButton();
  private ButtonGroup outBG = new ButtonGroup();
  private JPanel outJP = new JPanel();
  private Hashtable<String, JRadioButton> ht = new Hashtable<String, JRadioButton>();
  public JTextField sfJT = new JTextField("Sourcefile...");
  public FileConverter p;
  
  public ConvertPanel(FileConverter parent) {
    this.p = parent;

    ht.put("gsi", JRB_in_GSI_16);
    ht.put("dat", JRB_in_M5);
    ht.put("are", JRB_in_ARE);
    ht.put("pkt", JRB_in_PKT);
    ht.put("k", JRB_in_K);
    ht.put("csv", JRB_in_CSV);
    ht.put("001", JRB_in_OO1);

    sJR.add(JRB_in_GSI_8);
    sJR.add(JRB_in_GSI_16);
    sJR.add(JRB_in_DAT);
    sJR.add(JRB_in_M5);
    sJR.add(JRB_in_ARE);
    sJR.add(JRB_in_PKT);
    sJR.add(JRB_in_K);
    sJR.add(JRB_in_CSV);
    sJR.add(JRB_in_OO1);
    
    rJR.add(JRB_out_GSI_8);
    rJR.add(JRB_out_GSI_16);
    rJR.add(JRB_out_DAT);
    rJR.add(JRB_out_M5);
    rJR.add(JRB_out_ARE);
    rJR.add(JRB_out_PKT);
    rJR.add(JRB_out_K);
    rJR.add(JRB_out_CSV);
    rJR.add(JRB_out_OO1);

    inJP.setLayout(  new GridLayout(sJR.size(), 1, 0, 0)  );
    outJP.setLayout( new GridLayout(rJR.size(), 1, 0, 0)  );

    //this.setLayout( new FlowLayout( 1, 50, 15 )   );
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    
    this.setLayout(gbl);

    c.fill = GridBagConstraints.HORIZONTAL;   // wie Komponente Bereich fllen soll
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 0.5;                     // Breite
    c.weighty = 0.5;                     // Hhe
    c.insets = new Insets(5,5,5,5);
    
    for (int i=0; i<sJR.size(); i++){
      sJR.get(i).setText( this.p.lc.getEntry("Sourceformat", i));
      rJR.get(i).setText( this.p.lc.getEntry("Resultformat", i));
      sJR.get(i).setToolTipText( this.p.lc.getEntry("Sourceformattooltip", i));
      rJR.get(i).setToolTipText( this.p.lc.getEntry("Resultformattooltip", i));
      inBG.add( sJR.get(i) );
      outBG.add(rJR.get(i) );
      inJP.add(sJR.get(i));
      outJP.add(rJR.get(i));
    }

    saveSettings.setText( this.p.lc.getEntry("Selectiontab",0));
    sfJT.setEditable(false);

    c.gridx = 0;
    c.gridy = 0;
    c.gridwidth = 2;
    c.gridheight = 1;
    //c.insets
    gbl.setConstraints(sfJT, c);
    this.add( sfJT );
    
    c.gridx = 0;                        // x-Position
    c.gridy = 1;                        // y-Position
    c.gridwidth = 1;                    // Breite
    c.gridheight = 1;
    gbl.setConstraints(inJP, c);          // zum GridBagConstraints hinzufgen
    this.add( inJP );
    
    c.gridx = 1;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(outJP, c);
    this.add( outJP );

    c.fill = GridBagConstraints.NONE;
    c.gridx = 0;
    c.gridy = 2;
    c.gridwidth = 2;
    c.gridheight = 1;
    gbl.setConstraints(saveSettings, c);
    this.add( saveSettings );
    
    saveSettings.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        p.convertData(evt);
      }
    });

  }
  
  public void selectSourceFormatInformation(java.io.File f){
    String ext = f.getName().substring(f.getName().lastIndexOf('.')+1);
    if ( this.ht.containsKey(ext) ){
      this.ht.get(ext).setSelected(true);
    }

  }
  
}

