/************************************************************************
 *                  FileConverter JAVA Coords2K v2.0                    *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/

import java.io.*;
import java.util.*;
class Coords2K extends Toolbox{
  private File fileName;
  private Vector<Point23> points = null;
  private boolean zeroHight;
  private String codeAlt;
  private double x_add, y_add, z_add;
  public Coords2K() { }

  public Coords2K(File f, Vector<Point23> ps, boolean zH, String cA, double x_add, double y_add, double z_add) {
    if (ps != null){
      this.fileName = f;
      this.points = ps;
      this.zeroHight = zH;
      this.codeAlt = cA;
      this.x_add = x_add;
      this.y_add = y_add;
      this.z_add = z_add;
    }
  }
  
  public boolean writeFile(){
    try {
      BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream( this.fileName )));
      for (int i=0; i<this.points.size(); i++){
        if (this.points.get(i).is2DPoint()){
          String line = this.align("right", this.points.get(i).getPKT(), 16)+" ";
          line += this.points.get(i).is3DPoint() == true?7:3;
          line += this.setNumberFormat(this.points.get(i).getY()+y_add,14, 4, false, false);
          line += this.setNumberFormat(this.points.get(i).getX()+x_add,14, 4, false, false);
          
          if (this.points.get(i).is3DPoint())
            line += this.setNumberFormat(this.points.get(i).getZ()+z_add,13, 5, false, false)+" ";
          else if (this.zeroHight)
            line += this.setNumberFormat(0.0,13, 5, false, false)+" ";
          else
            line += this.align("right", " ", 15)+" ";

          if (this.points.get(i).getCode()!=null)
            line += this.align("right", this.points.get(i).getCode(), 4);
          else if (this.codeAlt != null)
            line += this.align("right", this.codeAlt, 4);

          bw.write(line);
          bw.newLine();
        }
      }
      bw.close();
    }
    catch (Exception e){
       System.err.println("Fehler, datei konnte nicht erstellt werden: " + e);
       return false;
    }
    return true;
  }
  
  
}

