/************************************************************************
 *                  FileConverter JAVA DAT2Coords v2.0                  *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/

import java.util.*;
import java.io.File;

class DAT2Coords extends Toolbox {
  private File fileName;
  private Vector<Point23> points = null;
  
  public DAT2Coords () { }

  public DAT2Coords(File f){
    if (f.exists() && f.isFile() && f.canRead() && (f.toString().toLowerCase().endsWith( ".dat" ) || f.toString().toLowerCase().endsWith( ".rec" ) || f.toString().toLowerCase().endsWith( ".rec500" ))){
      this.fileName = f;
      this.points = new Vector<Point23>();
      if (!this.getCoords() || this.points.size() < 1)
        this.points = null;
    }
  }

  public Vector getPoints(){
    return this.points;
  }

  private boolean getCoords(){
    if (this.fileName == null)
      return false;

    Vector<String> v = this.readSourcefile( this.fileName );
    if (v == null)
      return false;

    for (int i=0; i<v.size(); i++){
      Point23 p23 = new Point23();
      if (v.get(i).length()>=21){
        p23.setPKT((removeFirstZeros(v.get(i).substring(8,21))).trim()); //.replace(' ', '0')
      }
      if (v.get(i).length()>=35){
        p23.setCode( (removeFirstZeros(v.get(i).substring(21,35))).trim()); //.replace(' ', '0'));
      }
      if (v.get(i).length()>=50 && v.get(i).substring(35,38).trim().equalsIgnoreCase("Y")){
        try{
          p23.setY(new Double( Double.parseDouble(v.get(i).substring(38,50)) ));
        } catch(Exception e) {  }
      }
      if (v.get(i).length()>=66 && v.get(i).substring(50,53).trim().equalsIgnoreCase("X")){
        try{
          p23.setX(new Double(Double.parseDouble(v.get(i).substring(53,66))));
        } catch(Exception e) {  }
      }
      if (v.get(i).length()>=78 && v.get(i).substring(66,69).trim().equalsIgnoreCase("Z")){
        try{
          p23.setZ(new Double( Double.parseDouble(v.get(i).substring(69,78)) ));
        } catch(Exception e) {  }
      }
      if (p23.is2DPoint()){
        this.points.add( p23 );

      }
    }
    return true;
  }

}

