/************************************************************************
 *                       FileConverter JAVA 5.03                        *
 ************************************************************************
 * Copyright (C) 2005-09 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.File;
import java.util.Vector;
//import java.text.*;
import java.util.Hashtable;

public class FileConverter extends JFrame {
  // Anfang Variablen
  protected static final String version = "5.03";
  public LanguageChooser lc = new LanguageChooser("de.lng");
  private JPanel SoftwareNamejPanel = new JPanel();
  private JLabel SoftwareNamejLabel = new JLabel("FileConverter");
  private JLabel SoftwareDescriptionjLabel = new JLabel("geodtischer Datenwandler");
  private JPanel barjP = new JPanel();
  private JProgressBar bar = new JProgressBar();
  private JPanel mainPanel = new JPanel();
  public JTabbedPane ToolsjTabbedPane = new JTabbedPane();
  public File sourceFile = null;
  public ConvertPanel convP = new ConvertPanel(this);
  public SettingPanel settP = new SettingPanel(this);
  public MainMenu menu = new MainMenu(this);
  public ProgressMonitor progressMonitor;
  public JFileChooser jFC = new JFileChooser();
  
  // Ende Variablen

  public FileConverter(String title, String Icon, int frameWidth, int frameHeight, File sf) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { exitTool(); }
    });
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    try {
      this.setIconImage(new ImageIcon(getClass().getResource(Icon)).getImage());
    }
    catch ( Exception e ) { };

    this.setJMenuBar(menu);

    this.setSize(frameWidth, frameHeight);
    this.setMinimumSize( new Dimension(frameWidth,frameHeight));
    this.setLocation((screenSize.width - frameWidth) / 2, (screenSize.height - frameHeight) / 2);
    Container cp = getContentPane();
    cp.setLayout( new BorderLayout(5, 5) );

    // Anfang Komponenten
    
    // Lese die gespeicherten Einstellungen...
    StartUpSetting sus = new StartUpSetting();
    if (sus.readIniFile()){
      Hashtable<String, Object> ht = sus.getObjects();
      try {
        Vector<JRadioButton> sJR = (Vector<JRadioButton>)ht.get("sourceoption");
        if (sJR != null && sJR.size() == this.convP.sJR.size())
          for (int i=0; i<sJR.size(); i++)
            if (sJR.get(i).isSelected())
              this.convP.sJR.get(i).setSelected(true);
      }catch (Exception e) {}

      try {
        Vector<JRadioButton> rJR = (Vector<JRadioButton>)ht.get("resultoption");
        if (rJR != null && rJR.size() == this.convP.rJR.size())
          for (int i=0; i<rJR.size(); i++)
            if (rJR.get(i).isSelected())
              this.convP.rJR.get(i).setSelected(true);
      }catch (Exception e) {}
      
      try {
        Vector<JFormattedTextField> jftfV = (Vector<JFormattedTextField>)ht.get("globsettingsjftf");
        if (jftfV != null && jftfV.size() == this.settP.jftfV.size())
          for (int i=0; i<jftfV.size(); i++)
            this.settP.jftfV.get(i).setText( jftfV.get(i).getText() );
      }catch (Exception e) {}
      
      try {
        Vector<JTextField> jtfV = (Vector<JTextField>)ht.get("globsettingsjtf");
        if (jtfV != null && jtfV.size() == this.settP.jtfV.size())
        for (int i=0; i<jtfV.size(); i++)
          this.settP.jtfV.get(i).setText( jtfV.get(i).getText() );
      }catch (Exception e) {}
      
      try {
        boolean sz = (Boolean)ht.get("zerohight");
        this.settP.zeroHightJC.setSelected(sz);
      }catch (Exception e) {}
      
      try {
        this.sourceFile = (File)ht.get("sourceFile");
      }catch (Exception e) {}
    }
    
    
    if (!lc.isReady) {
      JOptionPane.showMessageDialog(null, "Sprachdatei konnte nicht geladen werden!", "Information", JOptionPane.INFORMATION_MESSAGE);
      return;
    }
    
    if (sf != null && sf.exists() && sf.isFile()){
      this.sourceFile = sf;
      this.convP.selectSourceFormatInformation(this.sourceFile);
      convP.sfJT.setText( sf.toString() );
    }
    
    SoftwareNamejPanel.setLayout( new GridLayout(2, 1, 0, -10) );
    SoftwareNamejPanel.add( SoftwareNamejLabel );
    SoftwareNamejPanel.add( SoftwareDescriptionjLabel );
    SoftwareNamejLabel.setFont(new Font("serif", 1, 28));
    SoftwareDescriptionjLabel.setFont(new Font("Monospaced", 1, 11));
    SoftwareNamejLabel.setHorizontalAlignment(0);
    SoftwareDescriptionjLabel.setHorizontalAlignment(0);
    SoftwareNamejLabel.setForeground(Color.GRAY);
    SoftwareDescriptionjLabel.setForeground(Color.GRAY);
    
    ToolsjTabbedPane.add( convP, this.lc.getEntry("Tabs", 0) );
    ToolsjTabbedPane.add( settP, this.lc.getEntry("Tabs", 1) );
    mainPanel.add(ToolsjTabbedPane);
    
    cp.add(mainPanel, BorderLayout.NORTH);

    cp.add(ToolsjTabbedPane, BorderLayout.CENTER);

    barjP.setLayout( new BorderLayout(15, 15)  );
    barjP.add(bar);

    bar.setStringPainted(true);
    bar.setString(this.lc.getEntry("Progressbar", 0));
    cp.add(bar, BorderLayout.SOUTH);
    // Ende Komponenten
    setVisible(true);
  }
  
  public void convertData(ActionEvent evt) {
    if (this.sourceFile != null && (evt.getSource() == convP.saveSettings || evt.getSource() == menu.saveMenu)){
      Thread SaveAndRunThread = new Thread() {
        public void run() {
          SwingUtilities.invokeLater( new Runnable() {
            public void run() {
              //bar.setStringPainted(false);
              bar.setString("");
              bar.setIndeterminate(true);
              if (convertFile() ) {
                bar.setStringPainted(true);
                bar.setString(lc.getEntry("Progressbar", 1));
                bar.setIndeterminate(false);
              }
              else {
                bar.setStringPainted(true);
                bar.setString(lc.getEntry("Progressbar", 2));
                bar.setIndeterminate(false);
              }
            }
          });
        }
      };
      SaveAndRunThread.start();
    }
    else {
      JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 6), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
    }
  }

  // Anfang Ereignisprozeduren
  public boolean convertFile() {
      double x_add, y_add, z_add;
      boolean zeroHeight = settP.zeroHightJC.isSelected();
      String codeAlt = settP.codeAltJT.getText().trim().equals("")?null:settP.codeAltJT.getText().trim();
      int nr_csv, code_csv, x_csv, y_csv, z_csv, res;
      Vector<Point23> p23 = null;
      //JFileChooser jFC = new JFileChooser();
      File resultFile = null;

      try { x_add = Double.parseDouble(settP.xJFTF.getText().replaceAll(",",".")); } catch(Exception e) { x_add = 0.0; settP.xJFTF.setText("0.0");};
      try { y_add = Double.parseDouble(settP.yJFTF.getText().replaceAll(",",".")); } catch(Exception e) { y_add = 0.0; settP.yJFTF.setText("0.0");};
      try { z_add = Double.parseDouble(settP.zJFTF.getText().replaceAll(",",".")); } catch(Exception e) { z_add = 0.0; settP.zJFTF.setText("0.0");};
      try { res = Integer.parseInt(settP.commaJFTF.getText()); } catch(Exception e) { res = 3; settP.commaJFTF.setText("3");};
      if (res>5){
        res = 5;
        settP.commaJFTF.setText("5");
      }
      else if (res < 3){
        res = 3;
        settP.commaJFTF.setText("3");
      }

      try { nr_csv = Integer.parseInt(settP.nrcsvJFTF.getText().replaceAll(",","")); } catch(Exception e) { nr_csv = 0; settP.nrcsvJFTF.setText("0");};
      try { code_csv = Integer.parseInt(settP.codecsvJFTF.getText().replaceAll(",","")); } catch(Exception e) { code_csv = 1; settP.codecsvJFTF.setText("1");};
      try { x_csv = Integer.parseInt(settP.xcsvJFTF.getText().replaceAll(",","")); } catch(Exception e) { x_csv = 2; settP.xcsvJFTF.setText("2");};
      try { y_csv = Integer.parseInt(settP.ycsvJFTF.getText().replaceAll(",","")); } catch(Exception e) { y_csv = 3; settP.ycsvJFTF.setText("3");};
      try { z_csv = Integer.parseInt(settP.zcsvJFTF.getText().replaceAll(",","")); } catch(Exception e) { z_csv = 4; settP.zcsvJFTF.setText("4");};
      
      if (convP.JRB_in_GSI_8.isSelected() && !convP.JRB_out_GSI_8.isSelected()){
        if ((p23 = new GSI2Coords( this.sourceFile, 8 ).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_GSI_16.isSelected() && !convP.JRB_out_GSI_16.isSelected()){
        if ((p23 = new GSI2Coords( this.sourceFile, 16 ).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_DAT.isSelected() && !convP.JRB_out_DAT.isSelected()){
        if ((p23 = new DAT2Coords( this.sourceFile).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_M5.isSelected() && !convP.JRB_out_DAT.isSelected()){
        if ((p23 = new M52Coords( this.sourceFile).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_ARE.isSelected() && !convP.JRB_out_ARE.isSelected()){
        if ((p23 = new ARE2Coords( this.sourceFile).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_PKT.isSelected() && !convP.JRB_out_PKT.isSelected()){
        if ((p23 = new PKT2Coords( this.sourceFile).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_K.isSelected() && !convP.JRB_out_K.isSelected()){
        if ((p23 = new K2Coords( this.sourceFile).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_CSV.isSelected() && !convP.JRB_out_CSV.isSelected()){
        String separator = settP.sepacsvJT.getText().trim();
        if ((p23 = new CSV2Coords( this.sourceFile, separator, nr_csv, code_csv, y_csv, x_csv, z_csv).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_in_OO1.isSelected() && !convP.JRB_out_OO1.isSelected()){
        if ((p23 = new OO12Coords( this.sourceFile).getPoints()) == null){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 1), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else {
        JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 2), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
        return false;
      }
      
      jFC.setCurrentDirectory( this.sourceFile );
      try { jFC.setSelectedFile( new File(this.sourceFile.getName().substring(0, this.sourceFile.getName().lastIndexOf(".") ) ) ); }catch(Exception e) { new File("fileconverter"); }
      jFC.setDialogType(JFileChooser.SAVE_DIALOG);
      jFC.setDialogTitle(this.lc.getEntry("Savedialog", 0));
      jFC.setApproveButtonText(this.lc.getEntry("Savedialog", 1));

      if (jFC.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
        resultFile = jFC.getSelectedFile();
      else
        return false;
      

      if (convP.JRB_out_GSI_8.isSelected()){
        resultFile = this.setExtension(resultFile, ".gsi");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2GSI( resultFile, p23, res, zeroHeight, codeAlt, 8, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_GSI_16.isSelected()){
        resultFile = this.setExtension(resultFile, ".gsi");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2GSI( resultFile, p23, res, zeroHeight, codeAlt, 16, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_DAT.isSelected()){
        resultFile = this.setExtension(resultFile, ".dat");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2DAT( resultFile, p23, res, zeroHeight, codeAlt, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_M5.isSelected()){
        resultFile = this.setExtension(resultFile, ".dat");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2M5( resultFile, p23, res, zeroHeight, codeAlt, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_ARE.isSelected()){
        resultFile = this.setExtension(resultFile, ".are");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2ARE( resultFile, p23, res, zeroHeight, codeAlt, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_PKT.isSelected()){
        resultFile = this.setExtension(resultFile, ".pkt");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2PKT( resultFile, p23, res, zeroHeight, codeAlt, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_K.isSelected()){
        resultFile = this.setExtension(resultFile, ".k");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2K( resultFile, p23, zeroHeight, codeAlt, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_CSV.isSelected()){
        resultFile = this.setExtension(resultFile, ".csv");
        String separator = settP.sepacsvJT.getText().trim();
        char commaType = settP.commacsvJT.getText().trim().equals("")?'.':(char)settP.commacsvJT.getText().trim().charAt(0);
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2CSV( resultFile, p23, res, zeroHeight, codeAlt, commaType, separator, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      else if (convP.JRB_out_OO1.isSelected()){
        resultFile = this.setExtension(resultFile, ".001");
        if (resultFile.exists() && JOptionPane.showConfirmDialog(null, this.lc.getEntry("Message", 5), this.lc.getEntry("Message", 4),JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION){
          return false;
        }
        if (!new Coords2OO1( resultFile, p23, res, zeroHeight, codeAlt, x_add, y_add, z_add).writeFile()){
          JOptionPane.showMessageDialog(null,this.lc.getEntry("Message", 3), this.lc.getEntry("Message", 0),JOptionPane.ERROR_MESSAGE);
          return false;
        }
      }
      bar.setStringPainted(true);
      bar.setString(lc.getEntry("Progressbar", 1));
      bar.setIndeterminate( false );
      return true;
  }
  
  private File setExtension(File f, String ext){
    if (f.toString().toLowerCase().endsWith(ext))
      return f;
    else
      return new File(f.toString()+ext);
  }
  
  
  public void openDialogActionPerformed(ActionEvent evt) {
    //JFileChooser jFC = new JFileChooser();
    if (this.sourceFile != null){
      jFC.setCurrentDirectory( this.sourceFile );
      jFC.setSelectedFile( this.sourceFile );
    }
    jFC.setDialogType(JFileChooser.OPEN_DIALOG);
    jFC.setDialogTitle(this.lc.getEntry("Opendialog", 0));
    jFC.setApproveButtonText(this.lc.getEntry("Opendialog", 1));

    if (jFC.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
      this.sourceFile = jFC.getSelectedFile();
      convP.sfJT.setText( this.sourceFile.toString() );
    }

  }
  
  public void HelpjButtonActionPerformed(ActionEvent evt) {
    HelpFrame help = null;
    Vector<HelpFile> HF = new Vector<HelpFile>();
    HF.add(new HelpFile("Inhaltsverzeichnis", "index.html"));
    HF.add(new HelpFile("Allgemeines", "allgemeines.html"));
    HF.add(new HelpFile("Formate", "format.html"));
    HF.add(new HelpFile("Lizenz", "lizenz.html"));
    HF.add(new HelpFile("Impressum", "impressum.html"));

    help = new HelpFrame("FileConverter - geodtischer Datenwandler v"+version+" Help by Michael Lsler [http://derletztekick.com]","fc_icon.png",HF,550,400,(this.getLocationOnScreen().x+15),(this.getLocationOnScreen().y+15),1);
  }
  
  // Schliee Anwendung
  public void exitTool(){
    Hashtable<String, Object> ht = new Hashtable<String, Object>();
    ht.put("sourceoption", this.convP.sJR);
    ht.put("resultoption", this.convP.rJR);
    ht.put("globsettingsjftf", this.settP.jftfV);
    ht.put("globsettingsjtf" , this.settP.jtfV);
    ht.put("zerohight" , this.settP.zeroHightJC.isSelected());
    ht.put("sourceFile" , this.sourceFile==null?"":this.sourceFile);
    StartUpSetting sus = new StartUpSetting(ht);
    sus.writeIniFile();
    System.exit(0);
  }
  // Ende Ereignisprozeduren

  public static void main(String[] args) {
    int fw = 550;
    int fh = 420;
    String ft = "FileConverter - geodtischer Datenwandler v"+version+" by Michael Lsler [http://derletztekick.com]";
    if (args.length == 1 && new File(args[0]).exists())
      new FileConverter(ft, "fc_icon.png", fw, fh, new File(args[0]));
    else
      new FileConverter(ft, "fc_icon.png", fw, fh, null);


  }
}

