/************************************************************************
 *                  FileConverter JAVA OO12Coords v2.0                  *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/
import java.util.*;
import java.io.File;

class OO12Coords extends Toolbox {
  private File fileName;
  private Vector<Point23> points = null;

  public OO12Coords () { }

  public OO12Coords(File f){
    if (f.exists() && f.isFile() && f.canRead() && (f.toString().toLowerCase().endsWith( ".OO1" ) || f.toString().toLowerCase().endsWith( ".001" ))){
      this.fileName = f;
      this.points = new Vector<Point23>();
      if (!this.getCoords() || this.points.size() < 1)
        this.points = null;
    }
  }

  public Vector getPoints(){
    return this.points;
  }

  private boolean getCoords(){
    if (this.fileName == null)
      return false;

    Vector<String> v = this.readSourcefile( this.fileName );
    if (v == null)
      return false;

    for (int i=0; i<v.size(); i++){
      Point23 p23 = new Point23();
      if (v.get(i).length()>=43 && v.get(i).substring(0,3).trim().equalsIgnoreCase("001")){
        p23.setPKT(v.get(i).substring(3,19).trim());
        try{
          p23.setY(new Double( Double.parseDouble(v.get(i).substring(19,31)) ));
        } catch(Exception e) {  }

        try{
          p23.setX(new Double( Double.parseDouble(v.get(i).substring(31,43)) ));
        } catch(Exception e) {  }

        if (v.get(i).length()>=52){
          try{
            p23.setZ(new Double( Double.parseDouble(v.get(i).substring(43,52)) ));
          } catch(Exception e) {  }
        }

        if (v.get(i).length()>=58 && v.get(i).substring(52,58).trim().length()!=0)
          p23.setCode(v.get(i).substring(52,58).trim());

        if (p23.is2DPoint())
          this.points.add( p23 );
      }
    }
    return true;
  }

}

