/************************************************************************
 *                 FileConverter JAVA SettingPanel v1.01                *
 ************************************************************************
 * Copyright (C) 200708 by Michael Loesler, http://derletztekick.com    *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.text.*;
import java.util.*;
public class SettingPanel extends JPanel{
  private FileConverter p;
  private JPanel pointAdds = new JPanel();
  private JPanel csvAdds = new JPanel();

  public JCheckBox zeroHightJC = new JCheckBox();
  public JLabel codeAltJL = new JLabel();
  public JTextField codeAltJT = new JTextField();
  
  private JLabel xJL = new JLabel();
  private JLabel yJL = new JLabel();
  private JLabel zJL = new JLabel();
  private JLabel commaJL = new JLabel();

  private DecimalFormat df_double = (DecimalFormat)DecimalFormat.getInstance(Locale.ENGLISH);
  private DecimalFormat df_int = (DecimalFormat)DecimalFormat.getInstance(Locale.ENGLISH);

  public JFormattedTextField xJFTF = null;
  public JFormattedTextField yJFTF = null;
  public JFormattedTextField zJFTF = null;
  public JFormattedTextField commaJFTF = null;

  private JLabel xcsvJL = new JLabel();
  private JLabel ycsvJL = new JLabel();
  private JLabel zcsvJL = new JLabel();
  private JLabel nrcsvJL = new JLabel();
  private JLabel codecsvJL = new JLabel();
  private JLabel commacsvJL = new JLabel();
  private JLabel sepacsvJL = new JLabel();
  
  public JFormattedTextField xcsvJFTF    = null;
  public JFormattedTextField ycsvJFTF    = null;
  public JFormattedTextField zcsvJFTF    = null;
  public JFormattedTextField nrcsvJFTF   = null;
  public JFormattedTextField codecsvJFTF = null;
  public JTextField commacsvJT = new JTextField();
  public JTextField sepacsvJT = new JTextField();
  
  public Vector<JFormattedTextField> jftfV = new Vector<JFormattedTextField>();
  public Vector<JTextField> jtfV = new Vector<JTextField>();

  public SettingPanel(FileConverter p) {
    this.p = p;
    GridBagLayout gbl = new GridBagLayout();
    pointAdds.setLayout(  gbl );
    GridBagConstraints c = new GridBagConstraints();
    c.fill = GridBagConstraints.HORIZONTAL;   // wie Komponente Bereich fllen soll
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 0.5;                     // Breite
    c.weighty = 0.5;                     // Hhe
    c.insets = new Insets(2,20,2,2);

    df_double.setGroupingUsed(false);
    df_double.applyPattern( "0.00000" );
    xJFTF = new JFormattedTextField( df_double );
    yJFTF = new JFormattedTextField( df_double );
    zJFTF = new JFormattedTextField( df_double );
    
    df_int.applyPattern( "0" );
    commaJFTF  = new JFormattedTextField( df_int );
    xcsvJFTF   = new JFormattedTextField( df_int );
    ycsvJFTF   = new JFormattedTextField( df_int );
    zcsvJFTF   = new JFormattedTextField( df_int );
    nrcsvJFTF  = new JFormattedTextField( df_int );
    codecsvJFTF= new JFormattedTextField( df_int );
    
    jftfV.add(xJFTF);
    jftfV.add(yJFTF);
    jftfV.add(zJFTF);
    jftfV.add(commaJFTF);

    jftfV.add(xcsvJFTF);
    jftfV.add(ycsvJFTF);
    jftfV.add(zcsvJFTF);
    jftfV.add(nrcsvJFTF);
    jftfV.add(codecsvJFTF);

    jtfV.add(commacsvJT);
    jtfV.add(sepacsvJT);
    jtfV.add(codeAltJT);
    
    zeroHightJC.setText( this.p.lc.getEntry("Settingtab", 1) );
    codeAltJL.setText( this.p.lc.getEntry("Settingtab", 2) );
    zeroHightJC.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 0) );
    codeAltJT.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 1) );
    
    xJL.setText(this.p.lc.getEntry("Settingtab", 4));
    yJL.setText(this.p.lc.getEntry("Settingtab", 5));
    zJL.setText(this.p.lc.getEntry("Settingtab", 6));
    
    xJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 2) );
    yJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 3) );
    zJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 4) );
    
    commaJL.setText(this.p.lc.getEntry("Settingtab", 7));
    commaJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 5) );
    
    pointAdds.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED), this.p.lc.getEntry("Settingtab", 0)));

    c.gridx = 0;                        // x-Position
    c.gridy = 0;                        // y-Position
    c.gridwidth = 3;                    // Breite
    c.gridheight = 1;                   // Hoehe
    gbl.setConstraints(zeroHightJC, c);        // zum GridBagConstraints hinzufgen
    pointAdds.add( zeroHightJC );

    c.gridx = 0;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(codeAltJL, c);
    pointAdds.add( codeAltJL );
    
    c.gridx = 1;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;

    gbl.setConstraints(codeAltJT, c);
    pointAdds.add( codeAltJT );

    JLabel dJL = new JLabel("");
    c.gridx = 2;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(dJL, c);
    pointAdds.add( dJL );
    
    c.gridx = 0;
    c.gridy = 2;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(xJL, c);
    pointAdds.add( xJL );

    c.gridx = 1;
    c.gridy = 2;
    c.gridwidth = 2;
    c.gridheight = 1;
    c.ipadx = 75;
    gbl.setConstraints(xJFTF, c);
    pointAdds.add( xJFTF );
    
    c.gridx = 0;
    c.gridy = 3;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(yJL, c);
    pointAdds.add( yJL );

    c.gridx = 1;
    c.gridy = 3;
    c.gridwidth = 2;
    c.gridheight = 1;
    gbl.setConstraints(yJFTF, c);
    pointAdds.add( yJFTF );
    
    c.gridx = 0;
    c.gridy = 4;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(zJL, c);
    pointAdds.add( zJL );

    c.gridx = 1;
    c.gridy = 4;
    c.gridwidth = 2;
    c.gridheight = 1;
    gbl.setConstraints(zJFTF, c);
    pointAdds.add( zJFTF );
    
    c.gridx = 0;
    c.gridy = 5;
    c.gridwidth = 1;
    c.gridheight = 1;
    gbl.setConstraints(commaJL, c);
    pointAdds.add( commaJL );

    c.gridx = 1;
    c.gridy = 5;
    c.gridwidth = 2;
    c.gridheight = 1;
    gbl.setConstraints(commaJFTF, c);
    pointAdds.add( commaJFTF );
    
    GridBagLayout gblCSV = new GridBagLayout();
    csvAdds.setLayout(  gblCSV );
    c = new GridBagConstraints();
    c.fill = GridBagConstraints.HORIZONTAL;   // wie Komponente Bereich fllen soll
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 1;                     // Breite
    c.weighty = 1;                     // Hhe
    c.insets = new Insets(2,10,2,2);

    csvAdds.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED), this.p.lc.getEntry("Settingtab", 8)));

    nrcsvJL.setText( this.p.lc.getEntry("Settingtab",   9) );
    codecsvJL.setText( this.p.lc.getEntry("Settingtab",10) );
    xcsvJL.setText( this.p.lc.getEntry("Settingtab",   11) );
    ycsvJL.setText( this.p.lc.getEntry("Settingtab",   12) );
    zcsvJL.setText( this.p.lc.getEntry("Settingtab",   13) );
    sepacsvJL.setText( this.p.lc.getEntry("Settingtab",   14) );
    commacsvJL.setText( this.p.lc.getEntry("Settingtab",  15) );


    nrcsvJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 6) );
    codecsvJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 7) );
    xcsvJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 8) );
    ycsvJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip", 9) );
    zcsvJFTF.setToolTipText( this.p.lc.getEntry("Settingtabtooltip",10) );
    sepacsvJT.setToolTipText( this.p.lc.getEntry("Settingtabtooltip",11) );
    commacsvJT.setToolTipText( this.p.lc.getEntry("Settingtabtooltip",12) );

    
    c.gridx = 0;
    c.gridy = 0;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(nrcsvJL, c);
    csvAdds.add( nrcsvJL );

    c.gridx = 0;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;

    gblCSV.setConstraints(nrcsvJFTF, c);
    csvAdds.add( nrcsvJFTF);
    
    c.gridx = 1;
    c.gridy = 0;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(codecsvJL, c);
    csvAdds.add( codecsvJL );

    c.gridx = 1;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(codecsvJFTF, c);
    csvAdds.add( codecsvJFTF);

    c.gridx = 2;
    c.gridy = 0;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(xcsvJL, c);
    csvAdds.add( xcsvJL );
    
    c.gridx = 2;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(xcsvJFTF, c);
    csvAdds.add( xcsvJFTF);
    
    c.gridx = 3;
    c.gridy = 0;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(ycsvJL, c);
    csvAdds.add( ycsvJL );

    c.gridx = 3;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(ycsvJFTF, c);
    csvAdds.add( ycsvJFTF);
    
    c.gridx = 4;
    c.gridy = 0;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(zcsvJL, c);
    csvAdds.add( zcsvJL );

    c.gridx = 4;
    c.gridy = 1;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(zcsvJFTF, c);
    csvAdds.add( zcsvJFTF);
    
    c.gridx = 0;
    c.gridy = 2;
    c.gridwidth = 3;
    c.gridheight = 1;
    gblCSV.setConstraints(sepacsvJL, c);
    csvAdds.add( sepacsvJL );

    c.gridx = 4;
    c.gridy = 2;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(sepacsvJT, c);
    csvAdds.add( sepacsvJT );
    
    c.gridx = 0;
    c.gridy = 3;
    c.gridwidth = 3;
    c.gridheight = 1;
    gblCSV.setConstraints(commacsvJL, c);
    csvAdds.add( commacsvJL );
    
    c.gridx = 4;
    c.gridy = 3;
    c.gridwidth = 1;
    c.gridheight = 1;
    gblCSV.setConstraints(commacsvJT, c);
    csvAdds.add( commacsvJT );
    




    GridBagLayout gblPanel = new GridBagLayout();
    GridBagConstraints cPanel = new GridBagConstraints();
    cPanel.fill = GridBagConstraints.NONE;
    cPanel.anchor = GridBagConstraints.CENTER;
    cPanel.weightx = 0.5;
    cPanel.weighty = 0.5;
    cPanel.insets = new Insets(2,2,2,2);
    this.setLayout( gblPanel );

    cPanel.gridx = 0;
    cPanel.gridy = 0;
    cPanel.gridwidth = 1;
    cPanel.gridheight = 1;
    gblPanel.setConstraints(pointAdds, cPanel);
    this.add( pointAdds );
    
    cPanel.gridx = 0;
    cPanel.gridy = 1;
    cPanel.gridwidth = 1;
    cPanel.gridheight = 1;
    gblPanel.setConstraints(csvAdds, cPanel);
    this.add( csvAdds );

    
  }
}

