/************************************************************************
 *                        LanguageChooser v1.1                          *
 ************************************************************************
 * Copyright (C) 2007 by Michael Loesler, http://derletztekick.com      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/

import java.io.*;
import java.util.*;

public class StartUpSetting {
  private Hashtable<String, Object> ht = null;
  private static File iniFile = new File("init.bin");
  
  public StartUpSetting(){  }
  
  public StartUpSetting(Hashtable<String, Object> ht) {
    this.ht = ht;
  }
  
  public Hashtable<String, Object> getObjects(){
    return this.ht;
  }
  
  public boolean readIniFile() {
    try {
      ObjectInputStream ois = new ObjectInputStream( new FileInputStream( this.iniFile ) );
      this.ht = (Hashtable<String, Object>)ois.readObject();
      ois.close();
    }
    catch (Exception e) {
      System.err.println(e);
      return false;
    }
    return true;
  }
  
  public boolean writeIniFile() {
    if (this.ht == null)
      return false;
    try {
      ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream( this.iniFile ));
      oos.writeObject( ht );
      oos.flush();
      oos.close();
    }
    catch (Exception e) {
      System.err.println(e);
      return false;
    }
    return true;
  }
  
  
}

