/************************************************************************
 *                   FileConverter JAVA Toolbox v1.2                    *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/
 
import java.util.*;
import java.text.DecimalFormat;
import java.io.*;
public class Toolbox {

  public Vector<String> readSourcefile(File sFile){
    if (!sFile.exists() || !sFile.isFile() || !sFile.canRead())
      return null;
    Vector<String> v = new Vector<String>();
    try {
      InputStream is = new FileInputStream( sFile );
      BufferedReader br = new BufferedReader(new InputStreamReader(is));
      String line = "";
      while (( line = br.readLine()) != null)
        v.add( line );
      br.close();
    }
    catch (Exception err) {
      System.err.println(err);
      return null;
    }
    return v;
  }
  
  public String removeChar(String s){
    return s.replaceAll(".*?([1-9]+?.*)", "$1");
  }

  public String removeFirstZeros(String s){
    return s.replaceAll("^0*(.+)", "$1");
  }

  
  public String setNumberFormat(Double d, int w, int e, boolean leadingZeros, boolean sign){
    String s = new String();
    if (leadingZeros)
      if (sign)
        s = String.format( Locale.ENGLISH, "%+0"+w+"."+e+"f", d );
      else
        s = String.format( Locale.ENGLISH, "%0"+w+"."+e+"f", d );
    else
      if (sign)
        s = String.format( Locale.ENGLISH, "%+"+w+"."+e+"f", d );
      else
        s = String.format( Locale.ENGLISH, "%"+w+"."+e+"f", d );
    if (w!=1)
      s = s.substring(s.length()-w);
    if (sign && s.charAt(0) != ' ' && (s.charAt(0) != '+' || s.charAt(0) != '-')){
      if (d.doubleValue()<0)
        s = "-"+s.substring(1);
      else
        s = "+"+s.substring(1);
    }
    return s;
  }
  
  
  public String align(String type, String s, int len){

    if (type.equalsIgnoreCase("left")){
      s = String.format(Locale.ENGLISH, "%-"+len+"s", s.trim() );
    }
    else if (type.equalsIgnoreCase("right")){
      s = String.format(Locale.ENGLISH, "%"+len+"s", s.trim() );
    }
    return s.substring(s.length()-len);
  }
  
//  
//  public String setBlankBehind(String str, int len) {
//    str = String.format(Locale.ENGLISH, .trim();
//    return str.substring(     )
//
//
//    if (str.length() < len){
//      for (int i=str.length(); i<len; i++){
//        str += c;
//      }
//      return new String(str);
//    }
//    return str.substring(str.length()-len,str.length());
//    //return str.substring(0,len);
//  }
//
//  public String setCharsBefore(String str, char c, int len) {
//    str = str.trim();
//    if (str.length() < len){
//      String ws = "";
//      for (int i=0; i<len-str.length(); i++){
//        ws += c;
//      }
//      return new String(ws+str);
//    }
//    return str.substring(str.length()-len,str.length());
//    //return str.substring(0,len);
//  }
//
//
//
//
  
}

