/************************************************************************
 *                            searchEngine v2.0                         *
 ************************************************************************
 * Copyright (C) 2005-07 by Michael Loesler, http://derletztekick.com   *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/

import java.io.*;
import javax.swing.JOptionPane;
import java.util.ArrayList;
import java.io.InputStream;

public class searchEngine {

  private String file = null;
  private String keywords[];
  private String Content = null;
  private ArrayList searchresult = null;
  public searchEngine() {  }

  public searchEngine(File file, String words) {
    this.file = file.toString();
    words = words.replace('+',' ');
    this.keywords = words.toLowerCase().split("[ \t\n\r\f]");
    this.Content = getFileContent();
  }
  
  public searchEngine(String text, String words) {
    this.file = null;
    this.Content = text;
    words = words.replace('+',' ');
    this.keywords = words.toLowerCase().split("[ \t\n\r\f]");
  }
  
  public String getContent(){
    return this.Content;
  }
  
  private String getFileContent(){
    if (this.file == null){
      return null;
    }
    String Str = "";
    try {
      InputStream is = searchEngine.class.getResourceAsStream("/"+this.file);
      BufferedReader readfile = new BufferedReader(new InputStreamReader(is));

      String line;
      while ( (line = readfile.readLine()) != null) {
        if (line.trim().length() != 0) {
          Str += line.trim().toLowerCase();
        }
      }
      readfile.close();
    }
    catch (IOException e) {
      JOptionPane.showMessageDialog(null, "Fehler beim Einlesen der Datei \n" + e.getMessage() + "!", "Fehler", JOptionPane.ERROR_MESSAGE);
      return null;
    }
    Str = Str.replaceAll("<[^>]*>","");
    Str = Str.replaceAll("&ouml;","");
    Str = Str.replaceAll("&Ouml;","");

    Str = Str.replaceAll("&auml;","");
    Str = Str.replaceAll("&Auml;","");

    Str = Str.replaceAll("&uuml;","");
    Str = Str.replaceAll("&Uuml;","");

    Str = Str.replaceAll("&szlig;","");
    return Str;
  }
  
  public boolean getResult(){
    if (this.Content == null){
      return false;
    }
    int m = 0;

    for (int k=0; k<keywords.length; k++){
      if (this.Content.indexOf(keywords[k], this.Content.indexOf(keywords[k])) != -1) {
        m++;
        if (m == (keywords.length)) {
          return true;
        }
      }
    }
    return false;
  }
}
